﻿;AHK+ 환경에서 동작 (autohotkey.tistory.com)


;-------------------------------------------------------------------------------
; CaptureModule class
;-------------------------------------------------------------------------------

;캡쳐모듈 제어용 오브젝트 획득 함수
GetCaptureModule()
{
  static capture_module
  if !capture_module {
    capture_module := new CCaptureModule
    SetTimer, __CaptureModuleTick, % 1000 // capture_module.GetMaxFPS()
  }
  return capture_module

  __CaptureModuleTick:
    capture_module.Tick()
  return
}

class CCaptureModule
{
  static ColorFormat = {0:"GS_UNKNOWNFORMAT", 1:"GS_ALPHA", 2:"GS_GRAYSCALE", 3:"GS_RGB", 4:"GS_RGBA", 5:"GS_BGR", 6:"GS_BGRA", 7:"GS_RGBA16F"
                    , 8:"GS_RGBA32F", 9:"GS_B5G5R5A1", 10:"GS_B5G6R5", 11:"GS_R10G10B10A2", 12:"GS_DXT1", 13:"GS_DXT3", 14:"GS_DXT5"}
  
  targetProcessRunningTimeLimit := 10
  
  hwndCapture := 0
  targetProcessID := 0
  targetTitle := ""
  targetClass := ""
  bErrorAcquiring := false
  bCapturing := false
  captureWaitCount := 0

  captureMethode := ""
  
  textureMutexes := [0,0]

  hRaderIsAlive := 0
  hSignalRestart := 0, hSignalEnd := 0
  hSignalReady := 0, hSignalExit := 0

  ;---------------------------------------------
  #SetMainClassByScriptDir, #RADER
  
  ;(중요)DLL파일은 메인스크립트 경로듸 \GraphicsCapture\ 폴더에 위치해야 하며, DLL파일명도 변경하지 말아야 한다.
  injectHelper := A_ScriptDir "\GraphicsCapture\injectHelper.exe"
  injectDll := A_ScriptDir "\GraphicsCapture\GraphicsCaptureModule.dll"
  ;---------------------------------------------
  

  __New(p*)
  {
    mainClsName := GetMainClassName()
    ;---------------------------------------------
    ;ahk process -> graphics app
    this.RESTART_CAPTURE_EVENT := "#RADER_RestartCapture" mainClsName
    this.END_CAPTURE_EVENT     := "#RADER_EndCapture" mainClsName
    
    ;graphics app -> ahk process
    this.CAPTURE_READY_EVENT   := "#RADER_CaptureReady" mainClsName
    this.APP_EXIT_EVENT        := "#RADER_AppExit" mainClsName
    
    this.TEXTURE_MUTEX1        := "#RADERTextureMutex1" mainClsName
    this.TEXTURE_MUTEX2        := "#RADERTextureMutex2" mainClsName
    
    this.INFO_MEMORY           := "Local\#RADERInfoMemory" mainClsName
    this.TEXTURE_MEMORY        := "Local\#RADERTextureMemory" mainClsName

    ;ahk process -> graphics app
    this.RADER_KEEPALIVE_EVENT := "#RADER_KeepAlive" mainClsName
    
    this.RADER_MOUULELOAD_EVENT	:= "#RADER_ModuleLoad"
    this.RADER_MOUULELOADERNOTICE_EVENT	:= "#RADER_ModuleLoaderNotice" mainClsName


    this.CAPTURETYPE_MEMORY    := 1
    this.CAPTURETYPE_SHAREDTEX := 2
    ;---------------------------------------------
    
    this.WAIT_OBJECT_0 := 0
    this.WAIT_TIMEOUT := 258
  }
  __Delete()
  {
    this.EndCapture()
  }
  
  ;-------------------------------------------
  ;(캡쳐0)캡쳐작업 감시
  Tick()
  {
    if !this.bCaptureBegin
      return
    
    ;Tick 호출 타임 체크
    if !this._tickOld
      this._tickOld := A_TickCount
    fMiliSeconds := A_TickCount - this._tickOld

    ;대상프로세스 종료 감지시
    if this.hSignalExit and (this.WaitForSingleObject(this.hSignalExit) = this.WAIT_OBJECT_0)
      this.EndCapture("refrash"), this.AddLog("대상프로그램종료 감지 (" this.targetTitle ")")

    ;캡쳐레디 이벤트 핸들 얻기
    if this.bCapturing and !this.hSignalReady and this.targetProcessID
      this.hSignalReady := this.GetEvent(this.CAPTURE_READY_EVENT)

    ;캡쳐레디 신호 있을시 - 대상윈도우 사이즈 변경시에도 이신호가 수신된다.
    if this.hSignalReady
    {
      val := this.WaitForSingleObject(this.hSignalReady)
      if (val = this.WAIT_OBJECT_0)
        this.__NewCapture()
      else if (val <> this.WAIT_TIMEOUT)
        Error("캡쳐레디 체크중 알수 없는 오류", A_ThisFunc)
    }

    ;캡쳐링 모드인데 캡쳐메소드 미지정시
    if this.bCapturing and !this.captureMethode
      if (++this.captureWaitCount >= this.GetMaxFPS())
        this.bCapturing := false , this.AddLog("캡쳐지연 감지(재시도대기)")
    
    this.captureCheckInterval += fMiliSeconds

    ;캡쳐중이 아닐시 캡쳐 재시작
    static lastErrorLog
    if !this.bCapturing and !this.bErrorAcquiring
    {
      ;대상(캡쳐모듈적용) 프로세스가 인식되지 않았을시 인식시도
      this.targetProcessID := this.__SearchTargetProcess()
      if runningTime := this.GetTargetRunningTime()
        if (runningTime > this.targetProcessRunningTimeLimit)
        {
          this.__AttemptCapture()
          this.captureCheckInterval := 0
        }
    }
    ;캡쳐중일 경우 캡쳐상태 체크
    else
    {
      if error := !this.IsWindow(this.hwndCapture) {
        if !this.bErrorAcquiring
          if (lastErrorLog <> (errorLog := "Module 캡쳐 대상윈도우 찾기 실패(hwnd=" (this.hwndCapture? this.hwndCapture:"미수신") ")"))
            this.AddLog(lastErrorLog := errorLog)
      }
      else if error := (captureCheckInterval >= 5000) {
        if (lastErrorLog <> (errorLog := "캡쳐지연 " (captureCheckInterval//1000) "초 이상"))
          this.AddLog(lastErrorLog := errorLog)
      }
      if error
        this.EndCapture("refrash")
    }
  }
  
  IsCaptureBegin()
  {
    return this.bCaptureBegin
  }
  
  ;(캡쳐1)캡쳐작업 시작 - 성공시 1리턴
  ;targetTitle : 대상프로세스 타이틀 또는 클래스가 있을시 {title:"", class:""} 오브젝트 사용
  BeginCapture(targetTitle="", ByRef retError="")
  {
    targetClass := targetTitle.class
    targetTitle := IsObject(targetTitle)? targetTitle.title:targetTitle

    if (targetTitle and this.targetTitle and (targetTitle<>this.targetTitle)) or (targetClass and this.targetClass and (targetClass<>this.targetClass))
      this.EndCapture("refrash")
    if targetTitle and (this.targetTitle := targetTitle)
    {
      this.targetClass := targetClass
      if !result := this.__AttemptCapture(retError)
        this.EndCapture("refrash")
    }
    this.bCaptureBegin := !!result
    return result
  }
  
  ;(캡쳐2) HBITMAP 이미지 반환
  GetCaptureHBITMAP()
  {
    if this.captureMethode {
      hBitmap := this.captureMethode.LockTexture()
      this.captureMethode.UnlockTexture()
    }
    return hBitmap
  }
  
  ;(캡쳐3)캡쳐작업 종료
  ;option = "refrash" : 캡쳐모듈 갱신을 위해 호출하는 경우
  EndCapture(option="")
  {
    ;캡쳐메소드 제거
    if this.captureMethode {
      this.captureMethode.Destroy()
      this.captureMethode := ""
    }

    if (option="refrash")
      this.bErrorAcquiring := false

    this.hwndCapture := 0
    this.targetProcessID := 0
    this.bCapturing := false
    this.captureWaitCount := 0
    this.captureCheckInterval := -1000

    this.hRaderIsAlive?  this.CloseHandle(this.hRaderIsAlive)  :"" , this.hRaderIsAlive := 0
    this.hSignalRestart? this.CloseHandle(this.hSignalRestart) :"" , this.hSignalRestart := 0
    this.hSignalEnd?     this.CloseHandle(this.hSignalEnd)     :"" , this.hSignalEnd := 0
    this.hSignalReady?   this.CloseHandle(this.hSignalReady)   :"" , this.hSignalReady := 0
    this.hSignalExit?    this.CloseHandle(this.hSignalExit)    :"" , this.hSignalExit := 0

    this.__CloseMutex()
    sleep, 100 ;삭제금지
    
    ;캡쳐모듈 갱신을 위해 호출한 경우가 아닐시 Tick() 갱신 비허용
    if (option<>"refrash")
      this.bCaptureBegin := false
  }

  SetMaxFPS(FPS)
  {
    if !this.bInitialized and (FPS>0 or FPS<20) {
      this.maxFPS := FPS
      return true
    }
    return false
  }

  GetMaxFPS()
  {
    if !this.maxFPS
      this.maxFPS := 10  ;기본값 10
    return this.maxFPS
  }

  ;모듈이 인젝트된 대상 프로세스의 런닝타임(초단위)을 얻는다.
  GetTargetRunningTime()
  {
    if pid := this.targetProcessID
      for process in ComObjGet("winmgmts:").ExecQuery("Select * from Win32_Process")
        if (pid=process.processID)
          if oldtime := SubStr(process.CreationDate,1,14)
          {
            flowSec := A_Now
            flowSec -= oldtime, Seconds
            return flowSec
          }
  }
  
  ;-------------------------------------------
  ;내부사용 클래스에서 참조되는 함수들
  ;-------------------------------------------
  ;클래스 내부 정의문 반환
  GetDefine(eventDefineName)
  {
    if (eventDefineName = "TEXTURE_MEMORY")
      return this.__GetValidEventName(this[eventDefineName], A_ThisFunc)
    else
      Error("잘못된 정의문 입니다.`n`neventDefineName = " eventDefineName, A_ThisFunc)
  }

  ;컬러포맷문자열 얻기
  GetColorFormatStringByID(index)
  {
    return this.ColorFormat[index]
  }

  ;생성된 텍스쳐뮤텍스 배열을 반환한다.
  GetTextureMutexArray()
  {
    return this.textureMutexes
  }

  ;-------------------------------------------
  ;내부 함수들
  ;-------------------------------------------
  ;(캡쳐시도1)캡쳐모듈 접근 시도
  ;retError = "Module_Used"    : 모듈이 다른 프로세스에서 이미 사용중인 상태
  ;retError = "Module_Invalid" : 대상 프로세스에 로딩된 캡쳐모듈이 존재하지만 현재 스크립트에서 로딩한 캡쳐모듈이 아님
  __AttemptCapture(ByRef retError="")
  {
    ;대상(캡쳐모듈적용) 프로세스가 인식되지 않았을시 인식시도
    if !this.targetProcessID or WinExist("ahk_pid " this.targetProcessID)
    {
      this.hwndCapture := 0 ;초기화
      this.targetProcessID := newProcessID := this.__SearchTargetProcess()
    }
    
    ;대상프로세스가 존재하지 않거나 모듈(dll)이 다른프로세스에서 사용중인지 체크
    if !this.targetProcessID or (useOtherProcess := this.__IsModuleDllLoadByOtherProcess())
    {
      if useOtherProcess
      {
        WinGetTitle, useOtherProcTitle, ahk_pid %useOtherProcess%
        retError := "Module_Used", this.AddLog("모듈을 다른프로세스에서 사용중" (useOtherProcTitle? "(" useOtherProcTitle ")":""))
      }
    }
    else
    {
      ;대상 프로세스에 캡쳐모듈이 로딩되어 있는지 체크
      if hSignalLoad := this.OpenEvent(this.RADER_MOUULELOAD_EVENT)
      {
        isModuleLoad := true, this.CloseHandle(hSignalLoad)
        if hSignalLoaderNotice := this.OpenEvent(this.RADER_MOUULELOADERNOTICE_EVENT)
          isModuleMatch := true, this.CloseHandle(hSignalLoaderNotice)
      }
  
      ;뮤텍스 오픈
      this.__OpenMutex()
  
      ;Rader 존재 이벤트 생성
      this.hRaderIsAlive := this.CreateEvent(this.RADER_KEEPALIVE_EVENT)
      ;CaptureRestart 이벤트가 존재시 바로 캡쳐시작
      if this.hSignalRestart := this.OpenEvent(this.RESTART_CAPTURE_EVENT)
      {
        this.bCapturing :=true
        this.SetEvent(this.hSignalRestart)
        this.captureWaitCount := 0
        result := true
      }
      ;대상 프로세스에 캡쳐모듈이 현재 스크립트에서 로딩한 캡쳐모듈이 아닐시
      else if isModuleLoad and !isModuleMatch
        retError := "Module_Invalid"
      ;새 대상 프로세스 연결시 캡쳐모듈 인젝트시도
      else if newProcessID
      {
        if !result := this.__InjectCaptureModule(retErrCode)
          if (retErrCode = -5)
            result := true
      }
    }
    this.bErrorAcquiring := !result
    return result
  }

  ;대상프로세스를 찾는다.
  __SearchTargetProcess()
  {
    if !this.targetTitle
      Error("대상 프로세스 타이틀 미설정", A_ThisFunc)
    modeBackup := A_TitleMatchMode
    SetTitleMatchMode, 3
    if this.targetClass {
      WinGet, id, list, % this.targetTitle
      loop %id%
        if (cur_id := id%A_Index%) {
          WinGetClass, class, % "ahk_id " cur_id
          if (class=this.targetClass) {
            WinGet, processID, PID, % "ahk_id " cur_id
            break
          }
        }
    }
    else
      WinGet, processID, PID, % this.targetTitle
    SetTitleMatchMode, % modeBackup
    return processID
  }

  ;(캡쳐시도2)새로운 캡쳐타입 설정
  __NewCapture()
  {
    ;기존 캡쳐타입(오브젝트) 제거
    if this.captureMethode {
      this.AddLog("이전캡쳐제거")
      this.captureMethode.Destroy()
      this.captureMethode := ""
    }

    if !this.hSignalRestart and !this.hSignalRestart := this.GetEvent(this.RESTART_CAPTURE_EVENT)
      Error("Restart 이벤트 생성실패", A_ThisFunc)
    if !this.hSignalEnd and !this.hSignalRestart := this.GetEvent(this.END_CAPTURE_EVENT)
      Error("End 이벤트 생성실패", A_ThisFunc)
    if !this.hSignalReady and !this.hSignalRestart := this.GetEvent(this.CAPTURE_READY_EVENT)
      Error("Ready 이벤트 생성실패", A_ThisFunc)
    if !this.hSignalExit and !this.hSignalRestart := this.GetEvent(this.APP_EXIT_EVENT)
      Error("Exit 이벤트 생성실패", A_ThisFunc)

    ;캡져정보 획득
    if !info := this.__GetCaptureInfo()
      return false

    this.hwndCapture := info.StructGet("hwndCapture")

    captureType := info.StructGet("captureType")
    if (captureType = this.CAPTURETYPE_MEMORY)
      this.captureMethode := new CMemoryCaptureMethode(this)
    else if (captureType = this.CAPTURETYPE_SHAREDTEX)
      MsgBox, 쉐이드텍스쳐 캡쳐타입 사용불가
    else
      MsgBox, 캡쳐타입 오류

    ;캡쳐타입에 적용 가능한 캡쳐메소드 적용시도
    if !this.captureMethode.Init(info)
    {
      this.captureMethode.Destroy()
      this.captureMethode := ""
    }
  }

  ;모듈 DLL이 목표 프로세스가 아닌 다른 프로세스에 로딩되어 있는지 체크
  ;반환값 : 사용중인 프로세스의 pid값
  __IsModuleDllLoadByOtherProcess()
  {
    dllPath := this.injectDll
    SplitPath, dllPath,, dllDir
    FileDelete, % dllLogFile := dllDir "\CaptureModuleLog.txt"
    FileRead, dllLog, % dllLogFile
    if this.targetProcessID and dllLog
      if RegExMatch(dllLog, "CaptureThread\: attached to process (.*?)\(PID=(.*?)\)", $) and (readName := $1) and (readPID := $2)
      {
        Winget, checkName, ProcessName, % "ahk_pid " readPID
        if (readPID<>this.targetProcessID) and (readName=checkName) and WinExist("ahk_pid " readPID)
          return readPID
      }
  }

  ;-------------------------------------------
  __OpenMutex()
  {
    if !this.textureMutexes[1] and (!this.textureMutexes[1] := DllCall("CreateMutex", "UPtr",0, "UInt",0, "Str",this.__GetValidEventName(this.TEXTURE_MUTEX1, A_ThisFunc)))
      return Error("textureMutexes1 생성실패 (ErrorCode = " DllCall("GetLastError") ")", A_ThisFunc)
    if !this.textureMutexes[2] and (!this.textureMutexes[2] := DllCall("CreateMutex", "UPtr",0, "UInt",0, "Str",this.__GetValidEventName(this.TEXTURE_MUTEX2, A_ThisFunc)))
      return Error("textureMutexes2 생성실패 (ErrorCode = " DllCall("GetLastError") ")", A_ThisFunc)
  }
  __CloseMutex()
  {
    this.textureMutexes[1]? this.CloseHandle(this.textureMutexes[1]):"" , this.textureMutexes[1] := 0
    this.textureMutexes[2]? this.CloseHandle(this.textureMutexes[2]):"" , this.textureMutexes[2] := 0
  }

  ;-------------------------------------------
  ;Win API Util
  ;-------------------------------------------
  OpenFileMapping(MainName)
  {
    FILE_MAP_ALL_ACCESS := 983071
    return DllCall("OpenFileMapping", "UInt",FILE_MAP_ALL_ACCESS, "UInt",0, "Str",this.__GetValidEventName(MainName, A_ThisFunc))
  }
  MapViewOfFile(handle, size)
  {
    FILE_MAP_ALL_ACCESS := 983071
    return DllCall("MapViewOfFile", "UPtr",handle, "UInt",FILE_MAP_ALL_ACCESS, "UInt",0, "UInt",0, "UInt",size)
  }
  CreateEvent(MainName)
  {
    return DllCall("CreateEvent", "UPtr",0, "UInt",0, "UInt",0, "Str",this.__GetValidEventName(MainName, A_ThisFunc))
  }
  OpenEvent(MainName)
  {
    EVENT_ALL_ACCESS := 0x000F0000|0x00100000|0x3
    return DllCall("OpenEvent", "UInt",EVENT_ALL_ACCESS, "UInt",0, "Str",this.__GetValidEventName(MainName, A_ThisFunc))
  }
  GetEvent(MainName)
  {
    if !hEvent := this.CreateEvent(MainName)
      hEvent := this.OpenEvent(MainName)
    return hEvent
  }
  SetEvent(handle)
  {
    return DllCall("SetEvent", "UPtr",handle)
  }
  IsWindow(hwnd)
  {
    return DllCall("IsWindow", "UPtr",hwnd)
  }
  WaitForSingleObject(handle, milliSec=0)
  {
    return DllCall("WaitForSingleObject", "UPtr",handle, "UInt",milliSec)
  }
  CloseHandle(handle)
  {
    return DllCall("CloseHandle", "UPtr",handle)
  }
  
  ;-------------------------------------------
  ;내부 유틸
  ;-------------------------------------------
  AddLog(text)
  {
    if func := Func("AddLog")
      func.call(text)
  }

  __InjectCaptureModule(ByRef retErrCode=0)
  {
    FileExist(this.injectHelper)? "":Error(RegExReplace(this.injectHelper, ".*\\") " 파일 없음`n`n" this.injectHelper, A_ThisFunc)
    FileExist(this.injectDll)? "":Error(RegExReplace(this.injectDll, ".*\\") " 파일 없음`n`n" this.injectDll, A_ThisFunc)

    safeMode := 0
    RunWait, % this.injectHelper " """ this.targetProcessID """ """ safeMode """ """ this.injectDll """"
    return !retErrCode := ErrorLevel
  }
  
  __GetValidEventName(MainName, callFrom="")
  {
    if !this.targetProcessID
      return Error("targetProcessID 미설정", (callFrom? callFrom "()->":"") A_ThisFunc)
    return MainName this.targetProcessID
  }

  __GetCaptureInfo()
  {
    if !hFileMap := this.OpenFileMapping(this.INFO_MEMORY)
      return false, Error("캡쳐정보획득실패 : 파일매핑오류1", A_ThisFunc)
    captureInfo := new CCaptureInfo
    if !mapPoint := this.MapViewOfFile(hFileMap, captureInfo.size) {
      DllCall("CloseHandle", "UPtr",hFileMap), hFileMap := 0
      Error("캡쳐정보획득실패 : 파일매핑오류2" (DllCall("GetLastError")=6? " - File handle 오류(404)":""), A_ThisFunc)
      return false
    }
    captureInfo.CopyFrom(mapPoint)
    mapPoint? DllCall("UnmapViewOfFile", "UPtr",mapPoint):""
    hFileMap? DllCall("CloseHandle", "UPtr",hFileMap):""
    return captureInfo
  }
}


;-------------------------------------------------------------------------------
; 캡쳐 메소드 클래스들 - 필수멤버 : Destroy(), Init(info), LockTexture(), UnlockTexture()
;-------------------------------------------------------------------------------
;OpenGL 캡쳐 메소드
class CMemoryCaptureMethode
{
  memoryMutex := ""
  hFileMap := 0
  sharedMemory := 0

  copyData := ""
  textureBuffers := [0,0]
  curTexture := 0

  hMutex := ""

  bInitialized := false

  width := 0
  height := 0
  pitch := 0
  format := -1

  ;-------------------------------------------
  __New(p*){
    if (p[1].__class <> (needCls := "CCaptureModule"))
      return Error(needCls " class의 인스턴스가 필요합니다.", A_ThisFunc)
    this.capture_module := p[1]
  }
  __Delete() {
    this.Destroy()
  }

  ;-------------------------------------------
  Destroy() {
    this.bInitialized := false

    if this.memoryMutex
      OSEnterMutex(this.memoryMutex)

    this.copyData := 0
    this.textureBuffers[0] := 0
    this.textureBuffers[1] := 0

    if this.sharedMemory
      DllCall("UnmapViewOfFile", "UPtr",this.sharedMemory), this.sharedMemory := 0

    if this.hFileMap
      DllCall("CloseHandle", "UPtr",this.hFileMap), this.hFileMap := 0

    if this.memoryMutex {
      OSLeaveMutex(this.memoryMutex)
      OSCloseMutex(this.memoryMutex)
      this.memoryMutex := 0
    }
    this.capture_module := ""
  }

  ;-------------------------------------------
  ;info : CCaptureInfo struct class object
  Init(info) {
    if (info.__class <> (validClassName := "CCaptureInfo"))
      Error("info 타입이 """ validClassName """ 가 아닙니다.`n`ninfo.__class = " info.__class, A_ThisFunc)
    
    this.width := info.StructGet("cx")
    this.height := info.StructGet("cy")
    this.pitch := info.StructGet("pitch")
    this.format := info.StructGet("format")

    strFileMapName := this.capture_module.GetDefine("TEXTURE_MEMORY") info.StructGet("mapID")
    this.hFileMap := OpenFileMapping(strFileMapName)

    if (this.hFileMap = 0)
      return Error("캡쳐링 초기화 실패 : 파일매핑 오픈 실패", A_ThisFunc)

    this.sharedMemory := MapViewOfFile(this.hFileMap, info.StructGet("mapSize"))
    if !this.sharedMemory
      return Error("캡쳐링 초기화 실패 : 파일매핑 맵뷰 실패", A_ThisFunc)

    this.memoryMutex := OSCreateMutex()
    if !this.memoryMutex
      return Error("캡쳐링 초기화 실패 : GL뮤텍스 생성실패", A_ThisFunc)

    ;----------
    WinGetTitle, title, % "ahk_pid " this.capture_module.targetProcessID
    this.capture_module.AddLog( "GL캡쳐적용 : size=" this.width "x" this.height ", pitch=" this.pitch ", bpp=" this.pitch//this.width*8
      . ", format=" this.capture_module.GetColorFormatStringByID(this.format) (title? ", title=" title "":"") )

    this.copyData := new CMemoryCopyData(this.sharedMemory)
    this.textureBuffers[0] := this.sharedMemory + this.copyData.StructGet("texture1Offset")
    this.textureBuffers[1] := this.sharedMemory + this.copyData.StructGet("texture2Offset")

    this.copyData.StructSet("frameTime", frameTime := 1000000//this.capture_module.GetMaxFPS())

    this.bInitialized := true
    return true
  }

  ;캡쳐함수
  LockTexture() {
    WAIT_OBJECT_0 := 0

    if !this.bInitialized or !this.copyData
      return ""

    ;텍스쳐뮤텍스배열 얻기
    textureMutexes := this.capture_module.GetTextureMutexArray()

    ;공유버퍼에서 캡쳐데이터 읽어오기
    OSEnterMutex(this.memoryMutex)
    this.curTexture := this.copyData.StructGet("lastRendered")
    if(this.curTexture < 2)
    {
      nextTexture := (this.curTexture = 1) ? 0 : 1
      if(WaitForSingleObject(textureMutexes[this.curTexture]) = WAIT_OBJECT_0)
        this.hMutex := textureMutexes[this.curTexture]
      else if(WaitForSingleObject(textureMutexes[nextTexture]) = WAIT_OBJECT_0) {
        this.hMutex := textureMutexes[nextTexture]
        this.curTexture := nextTexture
      }
      ;대상프로그램이 윈도우크기 변경중 일경우 this.hMutex 는 활성화 되지 않는다.
      if(this.hMutex) {
        bpp := this.pitch//this.width*8
        hBitmap := GetHBitmapFromBuffer(this.textureBuffers[this.curTexture], this.width, this.height, bpp)
        DllCall("ReleaseMutex", "UPtr",this.hMutex) , this.hMutex := 0
      }
    }
    OSLeaveMutex(this.memoryMutex)
    return hBitmap
  }

  UnlockTexture() {
  }
}

;-------------------------------------------------------------------------------
; 캡쳐 메소드 클래스들 - 필수멤버 : Destroy(), Init(info), LockTexture(), UnlockTexture()
;-------------------------------------------------------------------------------
;DirectX 쉐어드 캡쳐 메소드
class CSharedTexCaptureMethode
{
  hwndTarget := 0

  hFileMap := 0
  sharedMemory := 0

  texData := ""
  curTextureID := 0

  bInitialized := false

  width := 0
  height := 0
  pitch := 0
  format := -1

  ;-------------------------------------------
  __New(p*){
    if (p[1].__class <> (needCls := "CCaptureModule"))
      return Error(needCls " class의 인스턴스가 필요합니다.", A_ThisFunc)
    this.capture_module := p[1]
  }
  __Delete() {
    this.Destroy()
  }

  ;-------------------------------------------
  Destroy() {
    this.bInitialized := false

    this.capture_module := ""
  }

  ;-------------------------------------------
  ;info : CCaptureInfo struct class object
  Init(info) {
    if (info.__class <> (validClassName := "CCaptureInfo"))
      Error("info 타입이 """ validClassName """ 가 아닙니다.`n`ninfo.__class = " info.__class, A_ThisFunc)
    
    this.width := info.StructGet("cx")
    this.height := info.StructGet("cy")
    this.pitch := info.StructGet("pitch")
    this.format := info.StructGet("format")

    this.bInitialized := true
    return true
  }

  LockTexture() {
  }

  UnlockTexture() {
  }
}


;-------------------------------------------------------------------------------
; 구조체 랩퍼 클래스
;-------------------------------------------------------------------------------
class CCaptureInfo
{
  addr := ""
  size := ""
  __New(p*) {
    this.size := 36 ;<- struct sizeof()
    if p.MaxIndex() {
      if !addr := p[1]
        Error("구조체 주소 오류(null)", A_ThisFunc)
      else if addr is not integer
        Error("구조체 주소 오류(no addr)", A_ThisFunc)
      InStr(p[2], "*Copy")? this.CopyFrom(addr) : (p.MaxIndex()>1)? Error("옵션 파라미터 오류`n`noption = " p[2], A_ThisFunc): this.addr := addr
    }
    else
      ObjSetCapacity(this, "data", this.size)? this.addr := ObjGetAddress(this, "data"):""
  }
  CopyFrom(fromAddr) {
    if fromAddr is not Integer
      Error("구조체 주소 오류", A_ThisFunc)
    ObjSetCapacity(this, "data", this.size)
    this.addr := ObjGetAddress(this, "data")
    fromAddr? DllCall("RtlMoveMemory", "UPtr",this.addr, "UPtr",fromAddr, "UInt",this.size):""
  }
  StructGet(varName) {
    this.addr? "":Error("구조체 주소 미지정", A_ThisFunc)
    if (varName="captureType")
      value := NumGet(this.addr, 0, "UInt")
    else if (varName="format")
      value := NumGet(this.addr, 4, "UInt")
    else if (varName="cx")
      value := NumGet(this.addr, 8, "UInt")
    else if (varName="cy")
      value := NumGet(this.addr, 12, "UInt")
    else if (varName="bFlip")
      value := NumGet(this.addr, 16, "Int")
    else if (varName="pitch")
      value := NumGet(this.addr, 20, "UInt")
    else if (varName="mapID")
      value := NumGet(this.addr, 24, "UInt")
    else if (varName="mapSize")
      value := NumGet(this.addr, 28, "UInt")
    else if (varName="hwndCapture")
      value := NumGet(this.addr, 32, "UInt")
    else
      Error("존재하지 않는 변수명`n`nvarName = " varName, A_ThisFunc)
    return value
  }
  StructSet(varName, value) {
    this.addr? "":Error("구조체 주소 미지정", A_ThisFunc)
    return putAddr
  }
}

;----------------------------------------------------------------------------------
class CMemoryCopyData
{
  addr := ""
  size := ""
  __New(p*) {
    this.size := 24 ;<- struct sizeof()
    if p.MaxIndex() {
      if !addr := p[1]
        Error("구조체 주소 오류(null)", A_ThisFunc)
      else if addr is not integer
        Error("구조체 주소 오류(no addr)", A_ThisFunc)
      InStr(p[2], "*Copy")? this.CopyFrom(addr) : (p.MaxIndex()>1)? Error("옵션 파라미터 오류`n`noption = " p[2], A_ThisFunc): this.addr := addr
    }
    else
      ObjSetCapacity(this, "data", this.size)? this.addr := ObjGetAddress(this, "data"):""
  }
  CopyFrom(fromAddr) {
    if fromAddr is not Integer
      Error("구조체 주소 오류", A_ThisFunc)
    ObjSetCapacity(this, "data", this.size)
    this.addr := ObjGetAddress(this, "data")
    fromAddr? DllCall("RtlMoveMemory", "UPtr",this.addr, "UPtr",fromAddr, "UInt",this.size):""
  }
  StructGet(varName) {
    this.addr? "":Error("구조체 주소 미지정", A_ThisFunc)
    if (varName="lastRendered")
      value := NumGet(this.addr, 0, "UInt")
    else if (varName="frameTime")
      value := NumGet(this.addr, 8, "Int64")
    else if (varName="texture1Offset")
      value := NumGet(this.addr, 16, "UInt")
    else if (varName="texture2Offset")
      value := NumGet(this.addr, 20, "UInt")
    else
      Error("존재하지 않는 변수명`n`nvarName = " varName, A_ThisFunc)
    return value
  }
  StructSet(varName, value) {
    this.addr? "":Error("구조체 주소 미지정", A_ThisFunc)
    if (varName="lastRendered")
      putAddr := NumPut(value, this.addr, 0, "UInt")
    else if (varName="frameTime")
      putAddr := NumPut(value, this.addr, 8, "Int64")
    else if (varName="texture1Offset")
      putAddr := NumPut(value, this.addr, 16, "UInt")
    else if (varName="texture2Offset")
      putAddr := NumPut(value, this.addr, 20, "UInt")
    else
      Error("존재하지 않는 변수명`n`nvarName = " varName, A_ThisFunc)
    return putAddr
  }
}

;----------------------------------------------------------------------------------
class CSharedTexData
{
  addr := ""
  size := ""
  __New(p*) {
    this.size := 16 ;<- struct sizeof()
    if p.MaxIndex() {
      if !addr := p[1]
        Error("구조체 주소 오류(null)", A_ThisFunc)
      else if addr is not integer
        Error("구조체 주소 오류(no addr)", A_ThisFunc)
      InStr(p[2], "*Copy")? this.CopyFrom(addr) : (p.MaxIndex()>1)? Error("옵션 파라미터 오류`n`noption = " p[2], A_ThisFunc): this.addr := addr
    }
    else
      ObjSetCapacity(this, "data", this.size)? this.addr := ObjGetAddress(this, "data"):""
  }
  CopyFrom(fromAddr) {
    if fromAddr is not Integer
      Error("구조체 주소 오류", A_ThisFunc)
    ObjSetCapacity(this, "data", this.size)
    this.addr := ObjGetAddress(this, "data")
    fromAddr? DllCall("RtlMoveMemory", "UPtr",this.addr, "UPtr",fromAddr, "UInt",this.size):""
  }
  StructGet(varName) {
    this.addr? "":Error("구조체 주소 미지정", A_ThisFunc)
    if (varName="frameTime")
      value := NumGet(this.addr, 0, "Int64")
    else if (varName="texHandle")
      value := NumGet(this.addr, 8, "UInt")
    else
      Error("존재하지 않는 변수명`n`nvarName = " varName, A_ThisFunc)
    return value
  }
  StructSet(varName, value) {
    this.addr? "":Error("구조체 주소 미지정", A_ThisFunc)
    return putAddr
  }
}

;-------------------------------------------------------------------------------
OSCreateMutex() {
  mutexObj := {handle:0, mutexData:""}
  if ObjSetCapacity(mutexObj, "mutexData", A_PtrSize=8? 40:24)
    if mutexObj.handle := ObjGetAddress(mutexObj, "mutexData")
      return mutexObj, DllCall("InitializeCriticalSection", "UPtr",mutexObj.handle)
}
OSEnterMutex(mutexObj) {
  mutexObj.handle? DllCall("EnterCriticalSection", "UPtr",mutexObj.handle):""
}
OSTryEnterMutex(mutexObj) {
  return mutexObj.handle? DllCall("TryEnterCriticalSection", "UPtr",mutexObj.handle):""
}
OSLeaveMutex(mutexObj) {
  mutexObj.handle? DllCall("LeaveCriticalSection", "UPtr",mutexObj.handle):""
}
OSCloseMutex(mutexObj) {
  mutexObj.handle? DllCall("DeleteCriticalSection", "UPtr",mutexObj.handle):"", mutexObj.handle := mutexObj.mutexData := ""
}

;-------------------------------------------------------------------------------
OpenFileMapping(mappingName)
{
  FILE_MAP_ALL_ACCESS := 983071
  return DllCall("OpenFileMapping", "UInt",FILE_MAP_ALL_ACCESS, "UInt",0, "Str",mappingName)
}
MapViewOfFile(handle, size)
{
  FILE_MAP_ALL_ACCESS := 983071
  return DllCall("MapViewOfFile", "UPtr",handle, "UInt",FILE_MAP_ALL_ACCESS, "UInt",0, "UInt",0, "UInt",size)
}

;-------------------------------------------------------------------------------
GetHBitmapFromBuffer(buffer, width, height, bpp=32)
{
  if buffer and bpp and !Mod(bpp,8) and (bpp<=32) {
    hdc := DllCall("GetDC", "UPtr",0)
    if hbmp := CreateDIBSection(width, height, hdc, bpp) {
      VarSetCapacity(bufferInfo, 44, 0),NumPut(40, bufferInfo, 0, "UInt"),NumPut(width, bufferInfo, 4, "Int"),NumPut(height, bufferInfo, 8, "Int"),NumPut(1, bufferInfo, 12, "UShort"),NumPut(bpp, bufferInfo, 14, "UShort"),NumPut(width*height*bpp//8, bufferInfo, 20, "UInt")
      if !result := DllCall("SetDIBits", "UPtr",hdc, "UPtr",hbmp, "UInt",0, "UInt",height, "UPtr",buffer, "UPtr",&bufferInfo, "UPtr",0)
        DllCall("DeleteObject", "UPtr",hbmp), hbmp := 0
    }
    hdc? DllCall("ReleaseDC", "UPtr",0, "UPtr",hdc):""
  }
  return hbmp
}
CreateDIBSection(w, h, hdc="", bpp=32, ByRef ppvBits=0)
{
  Ptr := A_PtrSize ? "UPtr" : "UInt"
  hdc2 := hdc ? hdc : DllCall("GetDC", Ptr,0)
  if VarSetCapacity(bi, 40, 0) {
    NumPut(w, bi, 4, "uint"), NumPut(h, bi, 8, "uint"), NumPut(40, bi, 0, "uint")
    , NumPut(1, bi, 12, "ushort"), NumPut(0, bi, 16, "uInt"), NumPut(bpp, bi, 14, "ushort")
    hbm := DllCall("CreateDIBSection", Ptr,hdc2, Ptr,&bi, "UInt",0, A_PtrSize?"UPtr*":"uint*",ppvBits, Ptr,0, "UInt",0, Ptr)
  }
  if !hdc
    DllCall("ReleaseDC", Ptr,0, Ptr,hdc2)
  return hbm
}

;-------------------------------------------------------------------------------
WaitForSingleObject(handle, milliSec=0)
{
  return DllCall("WaitForSingleObject", "UPtr",handle, "UInt",milliSec)
}

;----------------------------------------------------------------------------------
GetMainClassName()
{
  AhkEnv, Get, name, MainClass
  if !InStr(name, "#RADER")
    Error("MainClassName 오류`n`nMainClassName = " name, A_ThisFunc)
  return name
}


