﻿;AHK+ 환경에서 동작 (autohotkey.tistory.com)


#SingleInstance, force
#include MomoCaptureModule.ahk

;캡쳐모듈 제어 오브젝트 얻기
capture_module := GetCaptureModule()

;캡쳐모듈 가동 시작
WinGet, targetProcessID, PID, % targetWinTitle := "LDPlayer"   ;LDPlayer 또는 Momo 앱플레이어를 대상으로만 사용가능
success := capture_module.BeginCapture(targetWinTitle, error)
MsgBox % (success? "캡쳐모듈 시작 성공":"캡쳐모듈 시작 실패" (error? "(" error ")":""))
        . "`n`nFoundPID = " targetProcessID
if success
  PopupSampleWindow(outSize := {w:800, h:480})
return


;캡쳐후 스샷 저장
F1::
  if hBitmap := capture_module.GetCaptureHBITMAP()
    SaveHBITMAPToFile(hBitmap, "_capture_" A_Now ".bmp"), DllCall("DeleteObject", "UPtr",hBitmap)
  TrayTip,, % hBitmap? "캡쳐성공":"캡쳐실패"
  hBitmap := 0
return

;캡쳐모듈 정지 및 재가동
F4::
  capture_module.EndCapture()
  capture_module.BeginCapture()
return



;-------------------------------------------------------------------------------

;에러 처리 함수
Error(msg, func="")
{
  MsgBox % (func? func "()`n`n":"") msg
  ExitApp
}

;로그추가
AddLog(msg="")
{
  IfNotExist % logDir := A_ScriptDir "\log"
    FileCreateDir, % logDir
  logFile := logDir "\log_" A_YYYY A_MM A_DD ".txt"
  
  if msg {
    msg = [%A_Hour%:%A_Min%:%A_Sec%] %msg%
    FileAppend, %msg%`n, % logFile    ;FileAppend, %A_DD%일 %msg%`n, % logFile
  }
}

SaveHBITMAPToFile(hBitmap, sFile)
{
  VarSetCapacity(DIBSECTION, A_PtrSize=8? 104:84, 0)
  NumPut(40, DIBSECTION, A_PtrSize=8? 32:24,"UInt") ;dsBmih.biSize
  DllCall("GetObject", "UPTR", hBitmap, "int", A_PtrSize=8? 104:84, "UPTR", &DIBSECTION)
  hFile:= DllCall("CreateFile", "UPTR", &sFile, "Uint", 0x40000000, "Uint", 0, "Uint", 0, "Uint", 2, "Uint", 0, "Uint", 0)
  DllCall("WriteFile", "UPTR", hFile, "int64P", 0x4D42|14+40+(biSizeImage:=NumGet(DIBSECTION, A_PtrSize=8? 52:44, "UInt"))<<16, "Uint", 6, "UintP", 0, "Uint", 0)
  DllCall("WriteFile", "UPTR", hFile, "int64P", 54<<32, "Uint", 8, "UintP", 0, "Uint", 0)
  DllCall("WriteFile", "UPTR", hFile, "UPTR", &DIBSECTION + (A_PtrSize=8? 32:24), "Uint", 40, "UintP", 0, "Uint", 0)
  DllCall("WriteFile", "UPTR", hFile, "Uint", NumGet(DIBSECTION, A_PtrSize=8? 24:20, "UPtr"), "Uint", biSizeImage, "UintP", 0, "Uint", 0)
  DllCall("CloseHandle", "UPTR", hFile)
}

;-------------------------------------------------------------------------------
;샘플윈도우에서 비트맵 보여주기
PopupSampleWindow(sampleOutSize="", LastGui="", hParents="")
{
  global SampleWindow_LastGui, SampleWindow_Alive
  global SampleWindow_PicSample, SampleWindow_hwndPicSample

  SampleWindow_LastGui := A_Gui? A_Gui:LastGui, SampleWindow_Alive := {}
  sampleOutSizeW := sampleOutSize.w? sampleOutSize.w:800
  sampleOutSizeH := sampleOutSize.h? sampleOutSize.h:480

  ;이전 스레드가 GUI 호출 스레드라면 해당 GUI 사용정지
  if SampleWindow_LastGui
  {
    hParents := hParents? hParents:WinExist()
    Gui, %SampleWindow_LastGui%: +Disabled
  }
  
  ;--------------------
  Gui, 20: Destroy
  Gui, 20: Default
  Gui, 20: Margin, 6, 6
  Gui, 20: Font, s8, 돋움
  Gui, 20: +LabelSampleWindow_ +LastFound -MinimizeBox +ToolWindow ;+AlwaysOnTop
  
  Gui, 20: Add, Picture, xm xp+2 w%sampleOutSizeW% h%sampleOutSizeH% 0xE vSampleWindow_PicSample hwndSampleWindow_hwndPicSample
  Gui, 20: Show,, Captureing Sample
  hWndSampleWindow := WinExist()
  point := CatchPopupPosition(hParents)
  WinMove, % "ahk_id " hWndSampleWindow,, % point.x, % point.y
  
  if SampleWindow_Alive.hdc_target := hdc_target := DllCall("GetDC", "UPtr",SampleWindow_hwndPicSample)
  if SampleWindow_Alive.hdc_source := hdc_source := DllCall("CreateCompatibleDC", "UPtr",hdc_target)
  loop
  {
    sleep, 100
    if !SampleWindow_Alive
      return SampleWindow_LastGui

    if (!samplingTick or (A_TickCount-samplingTick>200)) and (samplingTick := A_TickCount)
    if hBitmapSrc := GetCaptureModule().GetCaptureHBITMAP()
    {
      ImageGet,,,,,, hBitmapSrc, *HBmpNotDel, imageSize      
      hdc_source_selectOrg := DllCall("SelectObject", "UPtr",hdc_source, "UPtr",hBitmapSrc)
      DllCall( "gdi32.dll\StretchBlt"
              , UInt, hdc_target
              , Int , 0                       ; nXOriginDest
              , Int , 0                       ; nYOriginDest
              , Int , sampleOutSizeW          ; nWidthDest
              , Int , sampleOutSizeH          ; nHeightDest
              , UInt, hdc_source              ; hdcSrc
              , Int , 0                       ; nXOriginSrc 
              , Int , 0                       ; nYOriginSrc 
              , Int , imageSize.width         ; nWidthSrc 
              , Int , imageSize.height        ; nHeightSrc 
              , UInt, 0xCC0020)               ; dwRop (raster operation)
      if hdc_source_selectOrg
        DllCall("SelectObject", "UPtr",hdc_source, "UPtr",hdc_source_selectOrg), hdc_source_selectOrg := 0
    }
    if hBitmapSrc
      DllCall("DeleteObject", "UPtr",hBitmapSrc), hBitmapSrc := 0
  }

  ;--------------------  
  if 0
  {
    SampleWindow_Escape:
    SampleWindow_Close:
    
      if SampleWindow_Alive.hdc_target
        DllCall("ReleaseDC", "UPtr",SampleWindow_Alive.hdc_target), SampleWindow_Alive.hdc_target := 0
      if SampleWindow_Alive.hdc_source
        DllCall("DeleteDC", "UPtr",SampleWindow_Alive.hdc_source), SampleWindow_Alive.hdc_source := 0
      if SampleWindow_LastGui
        Gui, %SampleWindow_LastGui%: -Disabled
      Gui, 20: Destroy
      SampleWindow_Alive := ""
    return
  }
}

CatchPopupPosition(hParents, default="Left")
{
  hwnd := WinExist()
  WinGetPos, cx,cy,cw,ch, ahk_id %hwnd%
  WinGetPos, px,py,pw,ph, ahk_id %hParents%
  cy := py
  sw := A_ScreenWidth, sh := A_ScreenHeight
  cx := (px>cw)? px-cw:px+pw
  return {x:cx, y:cy}
}











